#ifndef _UADE_OS_UNIX_H_
#define _UADE_OS_UNIX_H_

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include "uademsg.h"

#define UADE_SIGALIVE 0
#define UADE_SIGHUP 1
#define UADE_SIGINT 2
#define UADE_SIGKILL 666

#define UADE_PATH_SCORE       (1)
#define UADE_PATH_UAERC       (2)
#define UADE_PATH_UADE        (3)
#define UADE_PATH_PLAYERDIR   (4)
#define UADE_PATH_FORMATSFILE (5)



#define UADE_SIGNALHANDLER(x) void x(int signum)

void uade_create_signalhandler(void (*sighandler)(int), int sigtype);

void uade_create_var_pid(void);

void uade_create_watchdog(uade_msgstruct *uade_struct, char *mapname);

uadepid_t uade_fork_exec(char **args);

char *uade_get_basename(char *path);

FILE *uade_get_file(int item);

int uade_get_path(char *path, int item);

int uade_get_temp_name(char *tempname);

uadepid_t uade_getpid(void);

int uade_if_normal_file(const char *filename);

int uade_init_mmap_file(const char *mapfilename);

void uade_init_outpipe(char *parameter);

void *uade_mmap_file(const char *filename);

FILE *uade_open_amiga_file(char *filename);

int uade_send_signal(uadepid_t pid, int sigtype);

void uade_sleep(int seconds);

void uade_usleep(int microseconds);

int uade_timer_poll(void);

char *uade_version(void);

void uade_write_to_outpipe(void *ptr, int size);

#endif
